/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */
package lab13;

import com.mongodb.BasicDBObject;
import com.mongodb.DB;
import com.mongodb.DBCollection;
import com.mongodb.DBCursor;
import com.mongodb.MongoClient;
import com.mongodb.client.MongoDatabase;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;

/**
 *
 * @author informatics
 */
public class ShowDocumentCondition extends javax.swing.JFrame {

    /**
     * Creates new form ShowDocumentCondition
     */
    public ShowDocumentCondition() {
        initComponents();
        this.setTitle("Find Condition");
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        LblShowCol = new javax.swing.JLabel();
        bntShowDoc = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        ListDoc = new javax.swing.JList<>();
        LblSearch = new javax.swing.JLabel();
        TextPrice = new javax.swing.JTextField();
        bntSearch = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        ListFixDoc = new javax.swing.JList<>();
        bntExit = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        LblShowCol.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 18)); // NOI18N
        LblShowCol.setText("แสดงข้อมูล Document ทั้งหมด");

        bntShowDoc.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14)); // NOI18N
        bntShowDoc.setText("แสดง Document");
        bntShowDoc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bntShowDocActionPerformed(evt);
            }
        });

        ListDoc.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 12)); // NOI18N
        ListDoc.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ListDocMouseClicked(evt);
            }
        });
        jScrollPane2.setViewportView(ListDoc);

        LblSearch.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14)); // NOI18N
        LblSearch.setText("ค้นหาแบบระบุเงื่อนไข  ระบุรหัส Employee (emp_id) : ");

        bntSearch.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 14)); // NOI18N
        bntSearch.setText("ค้นหา");
        bntSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bntSearchActionPerformed(evt);
            }
        });

        ListFixDoc.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 12)); // NOI18N
        jScrollPane3.setViewportView(ListFixDoc);

        bntExit.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 18)); // NOI18N
        bntExit.setText("Exit");
        bntExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bntExitActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(LblShowCol)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(61, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(bntShowDoc)
                        .addGap(28, 28, 28)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 441, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(26, 26, 26)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 441, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(LblSearch)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(TextPrice, javax.swing.GroupLayout.PREFERRED_SIZE, 153, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(bntSearch)))
                        .addGap(18, 18, 18)
                        .addComponent(bntExit)))
                .addGap(22, 22, 22))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(LblShowCol, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(bntExit, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(bntShowDoc)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(LblSearch, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(TextPrice, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(bntSearch))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(0, 17, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void bntShowDocActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bntShowDocActionPerformed
        // แสดงข้อมูล Document ใน Employee Collection
        try {
            //คำสั่งติดต่อกับฐานข้อมูล
            MongoClient mongo = new MongoClient("localhost", 27017);
            DB db = mongo.getDB("BigC");
            DBCollection table = db.getCollection("Employee");
            
            // แสดงข้อมูลที่เลือก
            DBCursor cursor = table.find();
            DefaultListModel modeil = new DefaultListModel();
            while (cursor.hasNext()) {
                modeil.addElement(cursor.next());
            }
            ListDoc.setModel(modeil);
        } catch (Exception e) {
            //e..printStackTrace();
        }
    }//GEN-LAST:event_bntShowDocActionPerformed

    private void bntExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bntExitActionPerformed
        setVisible(false); // คำสั่งปิดหน้าจอ
    }//GEN-LAST:event_bntExitActionPerformed

    private void bntSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bntSearchActionPerformed
        // แสดงข้อมูล Document ตามเงื่อนไขที่ระบุ
        try {
            //คำสั่งติดต่อกับฐานข้อมูล
             MongoClient mongo = new MongoClient("localhost", 27017);
             DB db = mongo.getDB("BigC");
             
             // แสดง MessageDialog กรณีช่องรับข้อมูลว่าง (ไม่มีการกรอกข้อมูล) 
             if(TextPrice.getText().isEmpty()) {
                 JOptionPane.showMessageDialog(this, "Please you input data");
             }else{
                 String tmp = TextPrice.getText();
                 DBCollection table = db.getCollection("Employee");
                 BasicDBObject searchQuery = new BasicDBObject();
                 searchQuery.put("emp_id",tmp);
                 DBCursor cursor = table.find(searchQuery);
                 DefaultListModel modeil1 = new DefaultListModel();
                 
                 while (cursor.hasNext()) {
                     modeil1.addElement(cursor.next());
                 }
                 ListFixDoc.setModel(modeil1);
                }
        } catch (Exception e) {
            //
        }
    }//GEN-LAST:event_bntSearchActionPerformed

    private void ListDocMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ListDocMouseClicked
        // กดเลือก Document ที่ List
        try {
            Object obj1 = ListDoc.getSelectedValue();
            String str = obj1.toString();
            
            JSONParser parser= new JSONParser();    
            Object obj = parser.parse(str);             // แปลงข้อมูลที่เลือกเป็น JSONObject
            JSONObject obj2 = (JSONObject)obj;
            TextPrice.setText((String)obj2.get("emp_id")); // การ Caching ข้อมูล
        } catch (Exception e) {
            //
        }
    }//GEN-LAST:event_ListDocMouseClicked

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ShowDocumentCondition.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ShowDocumentCondition.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ShowDocumentCondition.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ShowDocumentCondition.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ShowDocumentCondition().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel LblSearch;
    private javax.swing.JLabel LblShowCol;
    private javax.swing.JList<String> ListDoc;
    private javax.swing.JList<String> ListFixDoc;
    private javax.swing.JTextField TextPrice;
    private javax.swing.JButton bntExit;
    private javax.swing.JButton bntSearch;
    private javax.swing.JButton bntShowDoc;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    // End of variables declaration//GEN-END:variables
}
